
Name: liblely
Version: 0.1
Release: 6%{?dist}
Summary: lely-core librarie for CANopen

License: Apache-2.0
URL: http://git.ovh.iot/iotbzh/liblely.git
Source0: %{name}-%{version}.tar.gz

BuildRequires: afm-rpm-macros
BuildRequires: gcc gcc-c++
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  doxygen
BuildRequires:  graphviz
BuildRequires:  libtool
BuildRequires:  pkgconfig

%description
Lely core libraries is these libraries

C11 and POSIX compatibility library (liblely-libc)
liblely-libc makes a selection of C11 features available in C99 (and C++98) and implements certain C99 and POSIX features that may be missing on some platforms.
The library is intended to provide platform independence to C99- and
C11-compliant users.
See doc/libc/overview.md for an overview of the provided functionality.

Test Anything Protocol (TAP) library (liblely-tap)
liblely-tap provides an implementation of the Test Anything Protocol.

Utilities library (liblely-util)
liblely-util provides a variety of functions and data structures used by, and
shared between, other Lely libraries.
See doc/util/overview.md for an overview of the provided functionality.

CAN library (lely-can)
lely-can provides generic CAN frame definitions, conversion functions for
different drivers and an interface designed to simplify CAN frame handling.
See doc/can/overview.md for an overview of the
provided functionality.

I/O library (liblely-io2)
liblely-io provides uniform, platform-independent I/O interface for CAN devices,
regular files, serial I/O devices and network sockets. Depending on the
platform, some or all of these devices can be polled for events, allowing the
use of the reactor pattern.

Asynchronous I/O library (liblely-aio)
liblely-aio provides an event loop and asynchronous I/O. Currently only timers
and CAN devices are supported.

CANopen library (liblely-co)
liblely-co is a CANopen implementation for both masters and slaves. Most of the
functionality of [CiA] 301, 302, 305, 306, 309 and 315 is provided. The
implementation is passive; it does not perform any I/O or timing by itself.
Instead it relies on the user to send and received CAN frames and update the
clock. This allows the library to be integrated into a wide variety of
frameworks and communication patterns. The library uses the platform-independent
CAN frame definition from the Lely CAN library (liblely-can) and can be used
with the Lely I/O library (liblely-io).
Additionally, several tools are provided:

can2udp - CAN to UDP forwarding tool
cocat/cocatd - CANopen cat tools
coctl - CANopen control tool
dcf2c - CANopen EDS/DCF to C conversion tool

C++ CANopen application library (liblely-coapp)
liblely-coapp provides a high-level application interface in C++ for liblely-co.
It is intended to simplify the development of CANopen master applications (and,
to a lesser extent, slaves) by providing a driver model and combining it with an
event loop (from liblely-aio).

%package -n liblely-libc2
Summary:        LELY's C11 and POSIX compatibility library
Group:          Development/Libraries/C and C++

%description -n liblely-libc2
liblely-libc makes a selection of C11 features available in C99 (and C++98) and implements certain C99 and POSIX features that may be missing on some platforms.
The library is intended to provide platform independence to C99- and
C11-compliant users.
See doc/libc/overview.md for an overview of the provided functionality.

%package -n liblely-tap2
Summary:        Test Anything Protocol (TAP) library (liblely-tap)
Group:          Development/Libraries/C and C++

%description -n liblely-tap2
liblely-tap provides an implementation of the Test Anything Protocol.

%package -n liblely-util2
Summary:        Utilities library
Group:          Development/Libraries/C and C++

%description -n liblely-util2
liblely-util provides a variety of functions and data structures used by, and
shared between, other Lely libraries.
See doc/util/overview.md for an overview of the provided functionality.

%package -n liblely-can2
Summary:        CAN library
Group:          Development/Libraries/C and C++

%description -n liblely-can2
lely-can provides generic CAN frame definitions, conversion functions for
different drivers and an interface designed to simplify CAN frame handling.
See doc/can/overview.md for an overview of the
provided functionality.

%package -n liblely-io2-2
Summary:        I/O library
Group:          Development/Libraries/C and C++

%description -n liblely-io2-2
liblely-io provides uniform, platform-independent I/O interface for CAN devices,
regular files, serial I/O devices and network sockets. Depending on the
platform, some or all of these devices can be polled for events, allowing the
use of the reactor pattern.

%package -n liblely-io
Summary:        I/O library
Group:          Development/Libraries/C and C++

%description -n liblely-io
liblely-io provides uniform, platform-independent I/O interface for CAN devices,
regular files, serial I/O devices and network sockets. Depending on the
platform, some or all of these devices can be polled for events, allowing the
use of the reactor pattern.

%package -n liblely-ev2
Summary:        I/O library
Group:          Development/Libraries/C and C++

%description -n liblely-ev2
liblely-io provides uniform, platform-independent I/O interface for CAN devices,
regular files, serial I/O devices and network sockets. Depending on the
platform, some or all of these devices can be polled for events, allowing the
use of the reactor pattern.

%package -n liblely-co2
Summary:        CANopen library
Group:          Development/Libraries/C and C++

%description -n liblely-co2
liblely-co is a CANopen implementation for both masters and slaves. Most of the
functionality of [CiA] 301, 302, 305, 306, 309 and 315 is provided. The
implementation is passive; it does not perform any I/O or timing by itself.
Instead it relies on the user to send and received CAN frames and update the
clock. This allows the library to be integrated into a wide variety of
frameworks and communication patterns. The library uses the platform-independent
CAN frame definition from the Lely CAN library (liblely-can) and can be used
with the Lely I/O library (liblely-io).

%package -n liblely-coapp2
Summary:        C++ CANopen application library
Group:          Development/Libraries/C and C++

%description -n liblely-coapp2
liblely-coapp provides a high-level application interface in C++ for liblely-co.
It is intended to simplify the development of CANopen master applications (and,
to a lesser extent, slaves) by providing a driver model and combining it with an
event loop (from liblely-aio)


%package devel
Summary:        Development files for liblely-libc
Group:          Development/Libraries/C and C++
Requires:       liblely-can2 = %{version}
Requires:       liblely-co2 = %{version}
Requires:       liblely-io = %{version}
Requires:       liblely-io2-2 = %{version}
Requires:       liblely-libc2 = %{version}
Requires:       liblely-tap2 = %{version}
Requires:       liblely-util2 = %{version}

%description devel
Development headers for packages:

C11 and POSIX compatibility library (liblely-libc)
Test Anything Protocol (TAP) library (liblely-tap)
Utilities library (liblely-util)
CAN library (lely-can)
I/O library (liblely-io)
Asynchronous I/O library (liblely-aio)
CANopen library (liblely-co)
C++ CANopen application library (liblely-coapp)

%package tools
Summary:        Development files for liblely-libc
Group:          Development/Libraries/C and C++

%description tools
Mostly LELY's tools for CANOpen and CANBus

%prep
%autosetup -p 1

%build
autoreconf --verbose --force --install
libtoolize --force
aclocal --force
autoconf --force
automake --force --add-missing

%configure --disable-threads --disable-python --enable-static=no

%make_build

%install
%make_install
find %{buildroot} -type f -name "*.la" -delete -print
mkdir -p %{buildroot}/%{_docdir}
#mv  %{buildroot}%{_datadir}/doc/lely* %{buildroot}%{_docdir}

# As these should be same as in 1.9.x release they build in
# lely-core 1.9.3 build
#rm %{buildroot}%{_libdir}/liblely-can.so*
#rm %{buildroot}%{_libdir}/liblely-io.so*

%post -n liblely-libc2 -p /sbin/ldconfig
%postun -n liblely-libc2 -p /sbin/ldconfig
%post -n liblely-tap2 -p /sbin/ldconfig
%postun -n liblely-tap2 -p /sbin/ldconfig
%post -n liblely-io2-2 -p /sbin/ldconfig
%postun -n liblely-io2-2 -p /sbin/ldconfig
%post -n liblely-io -p /sbin/ldconfig
%postun -n liblely-io -p /sbin/ldconfig
%post -n liblely-ev2 -p /sbin/ldconfig
%postun -n liblely-ev2 -p /sbin/ldconfig
%post -n liblely-util2 -p /sbin/ldconfig
%postun -n liblely-util2 -p /sbin/ldconfig
%post -n liblely-can2 -p /sbin/ldconfig
%postun -n liblely-can2 -p /sbin/ldconfig
%post -n liblely-co2 -p /sbin/ldconfig
%postun -n liblely-co2 -p /sbin/ldconfig

%post -n liblely-coapp2 -p /sbin/ldconfig
%postun -n liblely-coapp2 -p /sbin/ldconfig

%files -n liblely-libc2
%{_libdir}/liblely-libc.so.2*

%files -n liblely-tap2
%{_libdir}/liblely-tap.so.2*

%files -n liblely-util2
%{_libdir}/liblely-util.so.2*

%files -n liblely-io2-2
%{_libdir}/liblely-io2.so.2*

%files -n liblely-io
%{_libdir}/liblely-io.so*

%files -n liblely-ev2
%{_libdir}/liblely-ev.so.2*

%files -n liblely-can2
%{_libdir}/liblely-can.so.*

%files -n liblely-co2
%{_libdir}/liblely-co.so.2*

%files -n liblely-coapp2
%{_libdir}/liblely-coapp.so.2*

%files devel
%dir %{_includedir}/lely
%{_includedir}/lely/*
%{_libdir}/liblely-*.so
%{_libdir}/pkgconfig/*.pc
%{_docdir}/*

%files tools
%{_sysconfdir}/cocatd.dcf
%{_bindir}/can2udp
%{_bindir}/cocatd
%{_bindir}/dcf2c

%changelog


